%% Prctica 6: Introduccin a las Comunicaciones Digitales
% Ejercicio 5: Mirando el receptor a los ojos

%% A)

clear;clc;close all;

K = 10;

T = 1;
dt = 1e-3*T;
t = 0:dt:K*T;

a = randint(K,1);
entrada = zeros(1,length(t));
salida = zeros(1,length(t));

for k = 0:K-1;
    
    entrada = entrada + (-1)^a(k+1)*xb(t-k*T,T);
    
end

for k = 0:K-1
    
    salida = salida + (-1)^a(k+1)*ya(t-k*T,T);

end

plot(t,entrada,'r',t,salida,'b');grid;
xlabel('t/T');ylabel('Amplitud');
legend('Seal Tx','Salida Rx',3);title('(A)');

figure;hold on;
for k = 2:K
    
    plot(salida(find(t >= (k-1)*T & t < (k+1)*T)));
    
end
hold off;grid
set(gca,'XTick',[0;(length(t)-1)/K;2*(length(t)-1)/K]);
set(gca,'XTickLabel',['0 ';'T ';'2T']);
title('A) Diagrama de Ojo');

%% B)

clear;clc;close all;

K = 10;

T = 1;
dt = 1e-3*T;
t = 0:dt:K*T;

a = randint(K,1);
entrada = zeros(1,length(t));
salida = zeros(1,length(t));

for k = 0:K-1;
    
    entrada = entrada + (-1)^a(k+1)*xb(t-k*T,T);
    
end

for k = 0:K-1
    
    salida = salida + (-1)^a(k+1)*yb(t-k*T,T);

end

plot(t,entrada,'r',t,salida,'b');grid;
xlabel('t/T');ylabel('Amplitud');
legend('Seal Tx','Salida Rx',3);title('(B)');

figure;hold on;
for k = 2:K
    
    plot(salida(find(t >= (k-1)*T & t < (k+1)*T)));
    
end
hold off;grid
set(gca,'XTick',[0;(length(t)-1)/K;2*(length(t)-1)/K]);
set(gca,'XTickLabel',['0 ';'T ';'2T']);
title('B) Diagrama de Ojo');

%% C)

clear;clc;close all;

K = 50;

T = 1;
dt = 1e-3*T;
t = 0:dt:K*T;

a = randint(K,1);
entrada = zeros(1,length(t));
salida = zeros(1,length(t));

for k = 0:K-1;
    
    entrada = entrada + (-1)^a(k+1)*yb(t-k*T,T);
    
end

for k = 0:K-1
    
    salida = salida + (-1)^a(k+1)*yc(t-k*T,T);

end

figure;plot(t,entrada,'r',t,salida,'b');grid;
xlabel('t/T');ylabel('Amplitud');
legend('Seal Tx','Salida Rx',3);title('(C)');

figure;hold on;
for k = 2:K-1
    
    plot(0:dt:2*T-dt,salida(find(t >= (k-1)*T & t < (k+1)*T)));
        
end
plot((T/3)*log(2*exp(3)-1)*ones(2,1),[-1 1],'k');
hold off;grid;
set(gca,'XTick',[0;T;2*T]);
set(gca,'XTickLabel',['0 ';'T ';'2T']);
title('C) Diagrama de Ojo');

%% Probabilidad de Error

ENR = 1:15;figure;
semilogy(ENR,qfunc(sqrt(2*10.^(0.1*ENR))),...
    ENR,qfunc(sqrt((4/3)*(0.9^2)*10.^(0.1*ENR))),'r',...
    ENR,qfunc(sqrt(2*(0.55^2)*10.^(0.1*ENR))));grid
title('Probabilidad de Error');xlabel('ENR');ylabel('P\{error\}');
legend('A) Canal con BW \infty','B) Filtro de un Polo como Rx','C) Canal Filtro de un Polo',3);
